// shphoneClientlibWrapper.h: CshphoneClientlibWrapper NX̃C^[tFCX
//
//////////////////////////////////////////////////////////////////////
#ifndef CSHPHONECLIENTLIBWRAPPER
#define CSHPHONECLIENTLIBWRAPPER

/* Defines */
#define WM_LIGHTMAIL_EVENT			0x632
#define MAX_SENDNUMBER_LEN			36				// ̍őoCg
#define MAX_SENDDATA_LEN			124				// Cg[{̍őoCg

/* Typedefs */
typedef struct _LightMailInfo_TAG {
	char	padding[160];							// s
	char	szLightMailNumber[MAX_SENDNUMBER_LEN];	// MCg[̔ԍ
	char	szLightMailData[MAX_SENDDATA_LEN];		// MCg[̖{
} LightMailInfo_TAG;

typedef void (__cdecl * PFNCSHPHONECLIENTLIB_CTOR)(void*, struct HWND__ *, int);
typedef void (__cdecl * PFNCSHPHONECLIENTLIB_DTOR)(void*);
typedef void (__cdecl * PFNSENDLIGHTMAIL)(void*, char*, char*);
typedef int (__cdecl * PFNGETLIGHTMAILINFO)(void*, LightMailInfo_TAG *);
typedef void (__cdecl * PFNRELEASECHANNEL)(void*);

typedef struct _SHPHONECLIENTLIBIF {
	PFNCSHPHONECLIENTLIB_CTOR	pfnCshphoneClientlib_Ctor;
	PFNCSHPHONECLIENTLIB_DTOR	pfnCshphoneClientlib_Dtor;
	PFNSENDLIGHTMAIL			pfnSendLightMail;
	PFNGETLIGHTMAILINFO			pfnGetLightMailInfo;
	PFNRELEASECHANNEL			pfnReleaseChannel;
} SHPHONECLIENTLIBIF;

/* Classes */
class CshphoneClientlibWrapper  
{
private:
	static int					ms_nRef;
	static HMODULE				ms_hModule;
	static SHPHONECLIENTLIBIF	ms_Entry;
	LPBYTE						m_pInstance;

public:
	CshphoneClientlibWrapper(HWND hWnd, int nID);
	virtual ~CshphoneClientlibWrapper();

	void SendLightMail(char* szNumber, char* szSendData);
	int GetLightMailInfo(LightMailInfo_TAG* pTag);
	void ReleaseChannel(void);
};

#endif

